# Elegant – an elegant theme for Pelican

[![Netlify Status](https://api.netlify.com/api/v1/badges/b4e4bf12-cd08-49ee-99b1-7fb343ecc2c4/deploy-status)](https://app.netlify.com/sites/pelicanelegant/deploys) [![Build Status](https://travis-ci.org/Pelican-Elegant/elegant.svg?branch=master)](https://travis-ci.org/Pelican-Elegant/elegant) [![code style: prettier](https://img.shields.io/badge/code_style-prettier-ff69b4.svg?style=flat-square)](https://github.com/prettier/prettier) [![Commitizen friendly](https://img.shields.io/badge/commitizen-friendly-brightgreen.svg)](http://commitizen.github.io/cz-cli/) [![License: MIT](https://img.shields.io/badge/License-MIT-yellow.svg)](https://opensource.org/licenses/MIT)

[Elegant][demo] is a theme for the static site generator [Pelican][].

It offers several unique features like search, live filter, collapsible
comments, Mailchimp, custom 404 page, and many more.

It is a minimal, and stylish theme that looks amazing across all screen
resolutions and devices.

## Live Demo

Visit [elegant.oncrashreboot.com][demo] to see theme in action, which is also
home to the documentation.

## Documentation

[![License: CC BY 4.0](https://licensebuttons.net/l/by/4.0/80x15.png)](https://creativecommons.org/licenses/by/4.0/)

Elegant is the only Pelican theme that offers comprehensive documentation.

The documentation can be viewed at [elegant.oncrashreboot.com][demo]. Its source code is in [documentation folder of this repository][doc_repo].

## How to contribute

Developing Elegant is a community effort. You are invited to help develop it further.

Feel free to fork the [repository][], and submit pull requests.

If you find any issues, or have a suggestion, then please open an [issue][].

## License

Elegant is released under the [MIT License][]. See [`THANKS.md`][thanks] file for a list of contributors.

Elegant's documentation is released under the [Creative Commons Attribution 4.0 International][cc-by-4.0] license.

All code contributions are made directly under the [MIT License][] as well. This is commonly referred to as the "Inbound=Outbound licensing model", as the license everyone contributes their code under (i.e. inbound license) is exactly the same as the license that the code is then being released under to the general public.

[pelican]: https://getpelican.com/
[repository]: https://github.com/Pelican-Elegant/elegant
[doc_repo]: ./documentation
[issue]: https://github.com/Pelican-Elegant/elegant/issues/
[contributing]: ./CONTRIBUTING.md
[thanks]: ./THANKS.md
[mit license]: https://spdx.org/licenses/MIT.html
[cc-by-4.0]: https://spdx.org/licenses/CC-BY-4.0.html
[demo]: https://elegant.oncrashreboot.com/
